// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from object_recognition_msgs:action/ObjectRecognition.idl
// generated code does not contain a copyright notice

#ifndef OBJECT_RECOGNITION_MSGS__ACTION__DETAIL__OBJECT_RECOGNITION__TRAITS_HPP_
#define OBJECT_RECOGNITION_MSGS__ACTION__DETAIL__OBJECT_RECOGNITION__TRAITS_HPP_

#include "object_recognition_msgs/action/detail/object_recognition__struct.hpp"
#include <rosidl_runtime_cpp/traits.hpp>
#include <stdint.h>
#include <type_traits>

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_Goal>()
{
  return "object_recognition_msgs::action::ObjectRecognition_Goal";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_Goal>()
{
  return "object_recognition_msgs/action/ObjectRecognition_Goal";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'recognized_objects'
#include "object_recognition_msgs/msg/detail/recognized_object_array__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_Result>()
{
  return "object_recognition_msgs::action::ObjectRecognition_Result";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_Result>()
{
  return "object_recognition_msgs/action/ObjectRecognition_Result";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_Result>
  : std::integral_constant<bool, has_fixed_size<object_recognition_msgs::msg::RecognizedObjectArray>::value> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_Result>
  : std::integral_constant<bool, has_bounded_size<object_recognition_msgs::msg::RecognizedObjectArray>::value> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_Feedback>()
{
  return "object_recognition_msgs::action::ObjectRecognition_Feedback";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_Feedback>()
{
  return "object_recognition_msgs/action/ObjectRecognition_Feedback";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "object_recognition_msgs/action/detail/object_recognition__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>()
{
  return "object_recognition_msgs::action::ObjectRecognition_SendGoal_Request";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>()
{
  return "object_recognition_msgs/action/ObjectRecognition_SendGoal_Request";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<object_recognition_msgs::action::ObjectRecognition_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<object_recognition_msgs::action::ObjectRecognition_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>()
{
  return "object_recognition_msgs::action::ObjectRecognition_SendGoal_Response";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>()
{
  return "object_recognition_msgs/action/ObjectRecognition_SendGoal_Response";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_SendGoal>()
{
  return "object_recognition_msgs::action::ObjectRecognition_SendGoal";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_SendGoal>()
{
  return "object_recognition_msgs/action/ObjectRecognition_SendGoal";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>::value &&
    has_fixed_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>::value &&
    has_bounded_size<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<object_recognition_msgs::action::ObjectRecognition_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<object_recognition_msgs::action::ObjectRecognition_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<object_recognition_msgs::action::ObjectRecognition_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>()
{
  return "object_recognition_msgs::action::ObjectRecognition_GetResult_Request";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>()
{
  return "object_recognition_msgs/action/ObjectRecognition_GetResult_Request";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "object_recognition_msgs/action/detail/object_recognition__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>()
{
  return "object_recognition_msgs::action::ObjectRecognition_GetResult_Response";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>()
{
  return "object_recognition_msgs/action/ObjectRecognition_GetResult_Response";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<object_recognition_msgs::action::ObjectRecognition_Result>::value> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<object_recognition_msgs::action::ObjectRecognition_Result>::value> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_GetResult>()
{
  return "object_recognition_msgs::action::ObjectRecognition_GetResult";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_GetResult>()
{
  return "object_recognition_msgs/action/ObjectRecognition_GetResult";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>::value &&
    has_fixed_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>::value &&
    has_bounded_size<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>::value
  >
{
};

template<>
struct is_service<object_recognition_msgs::action::ObjectRecognition_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<object_recognition_msgs::action::ObjectRecognition_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<object_recognition_msgs::action::ObjectRecognition_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "object_recognition_msgs/action/detail/object_recognition__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<object_recognition_msgs::action::ObjectRecognition_FeedbackMessage>()
{
  return "object_recognition_msgs::action::ObjectRecognition_FeedbackMessage";
}

template<>
inline const char * name<object_recognition_msgs::action::ObjectRecognition_FeedbackMessage>()
{
  return "object_recognition_msgs/action/ObjectRecognition_FeedbackMessage";
}

template<>
struct has_fixed_size<object_recognition_msgs::action::ObjectRecognition_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<object_recognition_msgs::action::ObjectRecognition_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<object_recognition_msgs::action::ObjectRecognition_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<object_recognition_msgs::action::ObjectRecognition_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<object_recognition_msgs::action::ObjectRecognition_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<object_recognition_msgs::action::ObjectRecognition>
  : std::true_type
{
};

template<>
struct is_action_goal<object_recognition_msgs::action::ObjectRecognition_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<object_recognition_msgs::action::ObjectRecognition_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<object_recognition_msgs::action::ObjectRecognition_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // OBJECT_RECOGNITION_MSGS__ACTION__DETAIL__OBJECT_RECOGNITION__TRAITS_HPP_
